package com.raulvibo.tester;

import android.accounts.Account;
import android.accounts.AccountManager;
import android.app.Application;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by raulvibo on 05/09/2017.
 */

public class Aplicacion extends Application {
    boolean opencvManagerInstalado = false;
    boolean permisoCamara = false;
    boolean permisoObtenerCuentas = false;
    boolean permisoAlmacenamiento = false;
    List<FichaTest> fichasTestsActivos;
    List<String> keysFichasTestsActivos;
    List<FichaTest> fichasTestsCreador;
    List<String> keysFichasTestsCreador;
    List<Integer> indicesMisFichasTests;

    @Override
    public void onCreate() {
        super.onCreate();
        fichasTestsActivos = new ArrayList<>();
        keysFichasTestsActivos = new ArrayList<>();
        fichasTestsCreador = new ArrayList<>();
        keysFichasTestsCreador = new ArrayList<>();
    }

    public List<FichaTest> getFichasTestsActivos() {
        return fichasTestsActivos;
    }

    public List<String> getKeysFichasTestsActivos() {
        return keysFichasTestsActivos;
    }

    public List<Integer> getIndicesMisFichasTests() {
        return indicesMisFichasTests;
    }

    public List<FichaTest> getFichasTestsCreador() {
        return fichasTestsCreador;
    }

    public List<String> getKeysFichasTestsCreador() {
        return keysFichasTestsCreador;
    }

    public boolean isOpencvManagerInstalado() {
        return opencvManagerInstalado;
    }

    public void setOpencvManagerInstalado(boolean opencvManagerInstalado) {
        this.opencvManagerInstalado = opencvManagerInstalado;
    }

    public boolean isPermisoCamara() {
        return permisoCamara;
    }

    public void setPermisoCamara(boolean permisoCamara) {
        this.permisoCamara = permisoCamara;
    }

    public boolean isPermisoObtenerCuentas() {
        return permisoObtenerCuentas;
    }

    public void setPermisoObtenerCuentas(boolean permisoObtenerCuentas) {
        this.permisoObtenerCuentas = permisoObtenerCuentas;
    }

    public boolean isPermisoAlmacenamiento() {
        return permisoAlmacenamiento;
    }

    public void setPermisoAlmacenamiento(boolean permisoAlmacenamiento) {
        this.permisoAlmacenamiento = permisoAlmacenamiento;
    }

    public boolean sePuedeCargarOpenCV() {
        return opencvManagerInstalado && permisoCamara;
    }

    public String getUsuario() {
        if (permisoObtenerCuentas) return getUsername();
        else return "anónimo";
    }

    //https://stackoverflow.com/questions/2727029/how-can-i-get-the-google-username-on-android
    public String getUsername() {
        AccountManager manager = AccountManager.get(this);
        Account[] accounts = manager.getAccountsByType("com.google");
        List<String> possibleEmails = new LinkedList<>();

        for (Account account : accounts) {
            // TODO: Check possibleEmail against an email regex or treat
            // account.name as an email address only for certain account.type values.
            possibleEmails.add(account.name);
        }

        if (!possibleEmails.isEmpty() && possibleEmails.get(0) != null) {
            String email = possibleEmails.get(0);
            String[] parts = email.split("@");

            if (parts.length > 1)
                return parts[0];
        }
        return "Anónimo";
    }
}