package com.raulvibo.tester;

/**
 * Created by raulvibo on 30/08/2017.
 */

public class FichaTest {
    private String titulo;
    private String descripcion;
    private String creador;
    private int numeroPreguntas;
    private long fechaCreacion;
    private String solucion;
    private boolean activo;

    public FichaTest(String titulo, String solucion) {
        this.titulo = titulo;
        this.solucion = solucion;
    }

    public FichaTest() {}

    public FichaTest(String titulo, String descripcion, String creador, int numeroPreguntas, long fechaCreacion, String solucion, boolean activo) {
        this.titulo = titulo;
        this.descripcion = descripcion;
        this.creador = creador;
        this.numeroPreguntas = numeroPreguntas;
        this.fechaCreacion = fechaCreacion;
        this.solucion = solucion;
        this.activo = activo;
    }

    public String getTitulo() {
        return titulo;
    }

    public void setTitulo(String titulo) {
        this.titulo = titulo;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public String getCreador() {
        return creador;
    }

    public void setCreador(String creador) {
        this.creador = creador;
    }

    public int getNumeroPreguntas() {
        return numeroPreguntas;
    }

    public void setNumeroPreguntas(int numeroPreguntas) {
        this.numeroPreguntas = numeroPreguntas;
    }

    public long getFechaCreacion() {
        return fechaCreacion;
    }

    public void setFechaCreacion(long fechaCreacion) {
        this.fechaCreacion = fechaCreacion;
    }

    public String getSolucion() {
        return solucion;
    }

    public void setSolucion(String solucion) {
        this.solucion = solucion;
    }

    public boolean isActivo() {
        return activo;
    }

    public void setActivo(boolean activo) {
        this.activo = activo;
    }

    public static class FichaTestBuilder {
        private String titulo = "";
        private String descripcion = "";
        private String creador = "";
        private int numeroPreguntas = 0;
        private long fechaCreacion;
        private String solucion = "";
        private boolean activo = false;

        public FichaTestBuilder withTitulo(String titulo) {
            this.titulo = titulo;
            return this;
        }

        public FichaTestBuilder withDescripcion(String descripcion) {
            this.descripcion = descripcion;
            return this;
        }

        public FichaTestBuilder withCreador(String creador) {
            this.creador = creador;
            return this;
        }

        public FichaTestBuilder withNumeroPreguntas(int numeroPreguntas) {
            this.numeroPreguntas = numeroPreguntas;
            return this;
        }

        public FichaTestBuilder withFechaCreacion(long fechaCreacion) {
            this.fechaCreacion = fechaCreacion;
            return this;
        }

        public FichaTestBuilder withSolucion(String solucion) {
            this.solucion = solucion;
            return this;
        }

        public FichaTestBuilder isActivo(boolean activo) {
            this.activo = activo;
            return this;
        }

        public FichaTest build() {
            return new FichaTest(titulo, descripcion, creador, numeroPreguntas, fechaCreacion, solucion, activo);
        }
    }
}
